#!/bin/bash

echo "Script to generate the pcap zip file"
sessionName="$1"
condition="$2"
path="$3"
command="$4"
allfiles="$5"
sessioncreationdate="$6"
sessioncreationtime="$7"
pcapFileName="$8"
regexConstant="-[0-9]{4}-(0[1-9]|1[0-2])-(0[1-9]|[1-2][0-9]|3[0-1])T([0-1][0-9]|2[0-3])-[0-5][0-9]-[0-5][0-9](|_[0-9]*)"
pcapRegex=$pcapFileName$regexConstant.pcap
time="$sessioncreationdate $sessioncreationtime"
cmdOutputLatestPcap=""
cd $path
if [ "$command" = "create" ]; then  
   echo "$path""$sessionName".zip
   if [ -f "$path""$sessionName".zip ]; then
      echo "File exists"
      echo "Deleting the file before creating"
      sudo rm "$path""$sessionName".zip
   fi
   if [ "$allfiles" = "true" ]; then
      echo "zip all files"
      cmdOutputLatestPcap=$(find $path -maxdepth 1 -type f -name "$pcapFileName*.pcap" -newermt "$time" ! -newermt "$(date --date="+1 minutes" +%F" "%T)" |grep -E $pcapRegex | xargs -n 1 basename)
   else
      echo "zip latest file"
      #cmdOutputLatestPcap=$(sudo ls -t|grep -E $pcapRegex |head -1)
      cmdOutputLatestPcap=$(find $path -maxdepth 1 -type f -name "$pcapFileName*.pcap" -newermt "$time" ! -newermt "$(date --date="+1 minutes" +%F" "%T)" | grep -E $pcapRegex | sort -r | head -1 | xargs -n 1 basename)
   fi
   echo $cmdOutputLatestPcap
   # adding double quotes so that the files having underscore are also taken care of
   sudo zip "$sessionName".zip $cmdOutputLatestPcap
   if [ "$condition" = "localAgent" ]; then
      sudo mv "$path""$sessionName".zip /opt/sdn/virgo/work/nv/ 
      sudo chmod 777 /opt/sdn/virgo/work/nv/"$sessionName".zip
   fi
else
   echo "Deleting the file"
   sudo rm "$path""$sessionName".zip
fi

#cmdOutputAllPcap=$(ls -t | grep -P $pcapRegex)
#operations on this can be extended in future release, if requirement arises   
#echo $cmdOutputAllPcap 
